/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2006 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.engine.xslt;

import java.io.ByteArrayOutputStream;
import java.io.InputStream;

import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

import org.objectweb.petals.component.framework.BusinessException;

/**
 *
 * @author alouis, ofabre
 *
 */
public class XsltImpl implements Xslt {


	public ByteArrayOutputStream transform(Source xml, InputStream xslResourceInputStream)
			throws BusinessException {

		Source source = new StreamSource(xslResourceInputStream);

		TransformerFactory transformerFactory = TransformerFactory
				.newInstance();
		try {
			Transformer transformer = transformerFactory.newTemplates(source)
					.newTransformer();

			ByteArrayOutputStream outputStream = transformSource(xml,
					transformer);
			return outputStream;
		} catch (TransformerConfigurationException e) {
			throw new BusinessException("Can't create XSL transformer", e);
		} catch (TransformerException e) {
			throw new BusinessException(
					"Can't transform xml content with the given xsl sheet", e);
		}

	}

	

	private ByteArrayOutputStream transformSource(Source xml,
			Transformer transformer) throws TransformerException {
		ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
		Result streamResult = new StreamResult(outputStream);
		transformer.transform(xml, streamResult);
		return outputStream;
	}

}
